--Program   : objs.sql 
--Purpose   : To find and display a list of all accessible objects that match a given criteria
--Usage     : SQL>@objs [owner[%].][[%]object_name|ALL|/]
--Notes     : The owner name, if omiited, defaults to the current user.
--Example   : SQL>@objs /	  -- displays a list of all objects owner by the current user.
--            SQL>@objs ALL       -- displays a list of all objects owner by the current user.
--            SQL>@objs SCOTT.EMP -- displays a list of all objects named like EMP% and owned by all users named like SCOTT%.
--Author    : Ram Razdan , ramrazdan@yahoo.com
--License   : Free for public use, amendment and distribution.
--            Please refer http://ramrazdan.tripod.com/termsofuse.txt for full details.
--Revision  : Version        Date        Server/OS        Comments
--            1.0            Dec,1997    Oracle7.1/SunOS  Initial Revision.
--            1.1            Apr,2001    Oracle8.1/Win98  Testing Only.
COLUMN "Owner.Object" FORMAT A61
COLUMN "Status"       FORMAT A15
COLUMN "Object Type"  FORMAT A20
SET FEEDBACK OFF
VARIABLE v_table_name VARCHAR2(30)
EXECUTE :v_table_name := '&1';
SET FEEDBACK ON
SELECT owner||'.'||object_name "Owner.Object"
      ,object_type             "Object Type"
      ,status                  "Status"
  FROM all_objects
 WHERE object_name LIKE DECODE(SUBSTR(UPPER(:v_table_name),INSTR(UPPER(:v_table_name),'.')+1)
                              ,'ALL',''
                              ,'/'  ,''
                              ,SUBSTR(UPPER(:v_table_name),INSTR(UPPER(:v_table_name),'.')+1))||'%'
   AND owner LIKE NVL(SUBSTR(upper(:v_table_name),1,INSTR(upper(:v_table_name),'.')-1),USER)||'%'
 ORDER BY object_type
/
